#ifndef PARADISO_GEOMETRY_HPP
#define PARADISO_GEOMETRY_HPP

#include "globals.hpp"

namespace paradiso
{

    struct Point final
    {
        using value_type = int32_t;
        value_type x{0}, y{0};
    };

    struct Size final
    {
        using value_type = uint32_t;
        value_type width{0}, height{0};

        constexpr auto area() const noexcept
        {
            return width * height;
        }
    };

    struct Rectangle
    {
        Point position;
        Size size;

        constexpr bool contains(const Point &p) const noexcept
        {
            return p.x >= position.x && p.x <= position.x + size.width &&
                   p.y >= position.y && p.y <= position.y + size.height;
        }
    };
}

#endif